#pragma once

#include <hilbert/kernel/storage.hpp>

namespace hilbert::kernel::storage::bd {

  class memory : public block_device {

  private:
    uint8_t *buffer;

  public:
    memory(void *buffer, uint64_t buffer_len);

    bd_result read_blocks_no_cache(
      uint64_t start, uint64_t count, void *into) override;

  };

}
